#include "mainwindow.h"
#include "ui_mainwindow.h"
 #include <QDebug>
#include <QTimer>
#include <QStringList>
#include <QMessageBox>
#include <QWebPage>
#include <QWebFrame>
 #include <QWebElementCollection>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    //Constructor
    ui->setupUi(this);
    // Now my stuff
    QTimer *timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(reload()));
    // Reload everything every 3 hours
    timer->start(10800000);   //This is in milliseconds. 1000msec = 1 sec, 3600000 = 1 hour, 21600000 = 6 hours, 10800000 = 3 hours
}

MainWindow::~MainWindow()
{
    //Destructor
    delete ui;
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainWindow::getit()
{
    idata = ui->webView_10->page(); //Create a QWebPage object for the web page we want to parse
}

void MainWindow::parseit()
{
    // Need to add return codes to this routine so I know when it gets bad data.
      QStringList ak_list;
      QStringList ssn_list;
      QStringList day1_line;
      QStringList day2_line;
      QStringList sf_list;
      QStringList sf_line;
     iframe = idata->mainFrame(); // Grabs the main frame from the web page so individual elements can be searched for.
    document = iframe->documentElement(); // Creates QWebElement from the frame.
    collection = document.findAll("table");  // All tables in the web page
    //qDebug() << "Tables found = " << collection.count() << "\n";

    // ************* A and K Index Planetary Numbers ***************
    table1 = collection.operator [](1);
    //qDebug() << "Table #1 = " << table1.toPlainText() << endl;
    table1_data = table1.firstChild();
    table1_collection = table1_data.findAll("tr");  // All tr's in the table
    //qDebug() << "Number of TR's in TABLE1 = " << table1_collection.count() << endl;
    tr_data_7 = table1_collection.operator [](7);  //
    //qDebug() << "A and K = " <<  tr_data_7.toPlainText() << endl;
    ak_line = tr_data_7.toPlainText();
    ak_list = ak_line.split("\t");
        // qDebug() << "ak_list size = " << ak_list.size() << endl;
    if(ak_list.size() != 19 ){
        QMessageBox msgBox;
        msgBox.setText("The page had bad data. Try to reload manually.");
        msgBox.exec();
        return;  // UhOh get out now! An error has been caught
       }
        a_index = ak_list[9];
    // K index is a bit harder
    for(int i = 0; i<=17; i++){
        if((ak_list[i] != "*") && (i != 9)){
        k_index = ak_list[i];
    }
    }
    //qDebug() << "A index = " << a_index << endl;
    //qDebug() << "K index = " << k_index << endl;
    // ******************* Solar Flux Number **********************
    table4 = collection.operator [](4);
    table4_data = table4.firstChild();
    table4_collection = table4_data.findAll("tr");  // All tr's in the table
    //qDebug() << "Number of TR's in TABLE4 = " << table4_collection.count() << endl;
    tr_data_sf = table4_collection.operator [](3);
    //qDebug() << "SF = " <<  tr_data_sf.toPlainText() << endl;
    sf_raw =  tr_data_sf.toPlainText();
    sf_line = sf_raw.split("\t");
    //qDebug() << "sf_line size = " << sf_line.size() << endl;
    if(sf_line.size() != 6 ){
        QMessageBox msgBox;
        msgBox.setText("The page had bad data. Try to reload manually.");
        msgBox.exec();
       return;  // UhOh get out now!  An error has been caught
       }
    sf = sf_line[1];
    //qDebug() << "SF = " << sf << endl;
    // ******************* Sun  Spot Number **********************
        // Currently table #5 has the Sun Spot Number, SSN.
        table5 = collection.operator [](5);
        table5_data = table5.firstChild();
        table5_collection = table5_data.findAll("tr");  // All tr's in the table
        //qDebug() << "Number of TR's in TABLE5 = " << table5_collection.count() << endl;
        num_days =  table5_collection.count() - 1;  // Count = 3 means two days of data.  ie., 3=2 and 2=1.  Aaarrrggghh.
        tr_data_1 = table5_collection.operator [](1);  // First date line.  Actually the first line is the headers.  ie., line 0.
        day1_raw = tr_data_1.toPlainText();
        day1_line = day1_raw.split("\t");
        //qDebug() << "DATE 1 = " <<  day1 << endl;
        if(num_days == 2){
        tr_data_2 = table5_collection.operator [](2);  // Second date line
        day2_raw = tr_data_2.toPlainText();
        day2_line = day2_raw.split("\t");
        //qDebug() << "DATE 2 = "  <<  day2 << endl;  // Need to test this to see how it handles NO second date data
    }
 // ***************************************************************
ssn = day1_line[1];
if(ssn == "*"){
   ssn = day2_line[1];  //Need to account for lack of data on a new GMT day
}

 // ***************** Display Results ***************************
ui->lcdNumber->display(ssn);
ui->lcdNumber_2->display(a_index);
ui->lcdNumber_3->display(k_index);
ui->lcdNumber_4->display(sf);
}


void MainWindow::on_test_PB_clicked()
{
       reload();
}

void MainWindow::on_webView_loadFinished(bool a)
{
    wv= a;
    pages_loaded();
}

void MainWindow::on_webView_2_loadFinished(bool a)
{
    wv_2 = a;
    pages_loaded();
}

void MainWindow::on_webView_3_loadFinished(bool a)
{
    wv_3 = a;
    pages_loaded();
}

void MainWindow::on_webView_4_loadFinished(bool a)
{
    wv_4 = a;
    pages_loaded();
}

void MainWindow::on_webView_5_loadFinished(bool a)
{
    wv_5 = a;
    pages_loaded();
}

void MainWindow::on_webView_6_loadFinished(bool a)
{
    wv_6 = a;
    pages_loaded();
}

void MainWindow::on_webView_7_loadFinished(bool a)
{
    wv_7 = a;
    pages_loaded();
}

void MainWindow::on_webView_8_loadFinished(bool a)
{
    wv_8 = a;
    pages_loaded();
}

void MainWindow::on_webView_9_loadFinished(bool a)
{
    wv_9 = a;
    pages_loaded();
}

void MainWindow::on_webView_10_loadFinished(bool a)
{
    wv_10 = a;
    pages_loaded();
}

void MainWindow::on_webView_11_loadFinished(bool a)
{
    wv_11 = a;
    pages_loaded();
}

void MainWindow::on_webView_12_loadFinished(bool a)
{
    wv_12 = a;
    pages_loaded();
}

void MainWindow::pages_loaded()
{
    if(wv && wv_2 && wv_3 && wv_4  && wv_5 && wv_6 && wv_7 && wv_8 && wv_9 && wv_10 && wv_11 && wv_12)
    {
        getit();
        parseit();
    }
}

void MainWindow::reload()
{
    //Holy crap!  Reload all the web pages.
    ui->webView->reload();
    ui->webView_2->reload();
    ui->webView_3->reload();
    ui->webView_4->reload();
    ui->webView_5->reload();
    ui->webView_6->reload();
    ui->webView_7->reload();
    ui->webView_8->reload();
    ui->webView_9->reload();
    ui->webView_10->reload();
    ui->webView_11->reload();
    ui->webView_12->reload();
    pages_loaded(); // ReDo calculations using new data.

}
